/*
 * Author: yeras-is
 */
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class FullScreenBrandLoader extends StatefulWidget {
  /// path image from Assets
  final String pathToAssetImg;

  /// height of Image Container
  final num height;

  const FullScreenBrandLoader({Key key, this.pathToAssetImg, this.height}) : super(key: key);

  @override
  _FullScreenBrandLoaderState createState() => _FullScreenBrandLoaderState();
}

class _FullScreenBrandLoaderState extends State<FullScreenBrandLoader>
    with TickerProviderStateMixin {
  AnimationController motionController;
  double opacityParam = 1;

  @override
  void initState() {
    super.initState();

    motionController = AnimationController(
      duration: Duration(milliseconds: 1300),
      lowerBound: 0.1,
      upperBound: 1,
      vsync: this,
    );

    motionController.forward();
    motionController.addStatusListener(
      (status) {
        setState(() {
          if (status == AnimationStatus.completed) {
            motionController.reverse();
          } else if (status == AnimationStatus.dismissed) {
            motionController.forward();
          }
        });
      },
    );

    motionController.addListener(() {
      setState(() {
        opacityParam = motionController.value;
      });
    });
  }

  @override
  void dispose() {
    motionController.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    var pathToAssetImg = widget.pathToAssetImg;
    return Scaffold(
      body: Center(
        child: AnimatedOpacity(
          duration: Duration(milliseconds: 1200),
          opacity: opacityParam,
          curve: Curves.slowMiddle,
          child: Container(
              height: widget.height ?? 100,
              decoration: BoxDecoration(
                image: DecorationImage(
                  image: pathToAssetImg != null
                      ? AssetImage(pathToAssetImg)
                      : NetworkImage(
                          'https://cdn.girlsleadership.org/app/uploads/2015/06/cupcakes-and-code-logo.png'),
                ),
              )),
        ),
      ),
    );
  }
}
